archive/urls.py
from django.urls import path

from archive import views

urlpatterns = [
    path('archive/create-archive/', views.ArchiveCreateView.as_view(), name='create-archive'),
    path('archive/list-archives/', views.ArchiveListView.as_view(), name='list-archives'),
    path('archive/list-archives/<int:pk>/', views.get_archive, name='list-selected-archive'),
    path('archive/update-archive/', views.ArchiveUpdateView.as_view(), name='update-archive'),
    path('archive/delete-archive/<int:pk>/', views.ArchiveDeleteView.as_view(), name='delete-archive'),
    path('archive/create-collection/', views.CollectionCreateView.as_view(), name='create-collection'),
    path('archive/list-collection/<int:pk>/', views.get_collection, name='list-selected-collection'),
    path('archive/view-file/<int:pk>/', views.display_file, name='list-archived-file'),
    path('archive/delete-collection/<int:pk>/', views.CollectionDeleteView.as_view(), name='delete-collection'),
    path('archive/update-collection/<int:pk>/', views.CollectionUpdateView.as_view(), name='update-collection'),
    path('archive/create-parrent-collection/', views.archive_create_view, name='create-new-collection'),
    path('archive/search/', views.search_view, name='search'),
    path('file/upload/<int:collection_id>/', views.ArchivedFileCreateView.as_view(), name='file-upload'),
    path('file/update/<int:pk>/', views.ArchivedFileUpdateView.as_view(), name='file-update'),
    path('file/<int:pk>/', views.ArchivedFileDeleteView.as_view(), name='file-delete'),
]

docu_flow_archive/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('', include('home.urls')),
    path('users/', include('user.urls')),
    path('archive/', include('archive.urls')),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

home/urls.py
from django.conf.urls import url
from django.urls import path

from home import views

urlpatterns = [

    path('', views.homepage_view, name='homePage'),
    url(r'^pdf', views.pdf, name='pdf'),

]

archive/models.py
import ast
import cv2
import numpy as np
import pytesseract
import os
import threading
import fitz

from typing import Tuple
from django.db import models

from user.models import UserExtend

NAME_LENGTH = 25


class Archive(models.Model):
    archive_name = models.CharField(max_length=NAME_LENGTH, null=False, blank=False)
    description = models.CharField(max_length=50, null=True, blank=True)
    creation_date = models.DateTimeField(auto_now_add=True)
    created_by = models.ForeignKey(UserExtend, on_delete=models.CASCADE, null=True, blank=True)

    def __str__(self):
        return self.archive_name


class DocumentTemplate(models.Model):
    dt_name = models.CharField(max_length=NAME_LENGTH, null=False, blank=False)
    template_file = models.FileField(null=True, blank=True, upload_to='DocumentTemplate/')
    archive = models.ForeignKey(Archive, on_delete=models.CASCADE, null=True, blank=True)

    def __str__(self):
        return self.dt_name

    def delete(self, *args, **kwargs):
        self.template_file.delete(save=False)
        super().delete(*args, **kwargs)


class RegionOfInterest(models.Model):
    roi_name = models.CharField(max_length=NAME_LENGTH, null=False, blank=False)
    region_points = models.TextField(null=True, blank=True)
    document_template = models.ForeignKey(DocumentTemplate, on_delete=models.CASCADE, null=True, blank=True)

    def __str__(self):
        return self.roi_name


class Collection(models.Model):
    collection_name = models.CharField(max_length=NAME_LENGTH, null=False, blank=False)
    parent_collection = models.ForeignKey('self', on_delete=models.CASCADE, null=True, blank=True)
    archive = models.ForeignKey(Archive, on_delete=models.CASCADE)

    def __str__(self):
        return self.collection_name


class UploadedFile(models.Model):
    document_template = models.ForeignKey(DocumentTemplate, on_delete=models.SET_NULL, null=True, blank=True)
    filename = models.FileField(null=False, blank=False, upload_to='pdfs/')
    search_metadata = models.CharField(max_length=254, null=True, blank=True)
    is_ocr = models.BooleanField(default=True)
    created_on = models.DateTimeField(auto_now_add=True)
    created_by = models.ForeignKey(UserExtend, on_delete=models.DO_NOTHING, null=True, blank=True)
    collection = models.ForeignKey(Collection, on_delete=models.CASCADE, null=True, blank=True)

    def __str__(self):
        return f'{self.filename}'

    def file_name(self):
        base = self.filename.name
        return os.path.splitext(base)[0]

    def delete(self, *args, **kwargs):
        self.filename.delete(save=False)
        super(UploadedFile, self).delete(*args, **kwargs)

    def save(self, *args, **kwargs):
        if self.pk is not None:
            super(UploadedFile, self).save(*args, **kwargs)
        else:
            super(UploadedFile, self).save(*args, **kwargs)
            region_points = RegionOfInterest.objects.get(document_template_id=self.document_template.id).region_points
            threading.Thread(target=do_ocr,
                             args=(str(self.document_template.template_file.file), ast.literal_eval(region_points),
                                   str(self.filename.file),
                                   self.id)).start()


def do_ocr(template_file, roi, file_to_ocr, file_id):
    per = 100
    extension = os.path.splitext(file_to_ocr)[1][1:]
    converted = 0
    if str.lower(extension) == 'pdf':
        file_to_ocr = convert_pdf2img(file_to_ocr)
        file_to_delete = file_to_ocr
        converted += 1
    pytesseract.pytesseract.tesseract_cmd = 'C:\\Program Files\\Tesseract-OCR\\tesseract.exe'
    imgOriginal = cv2.imread(template_file)
    # h, w, c = imgOriginal.shape
    orb = cv2.ORB_create(1000)  # creeaza punctele comune
    kp1, desc1 = orb.detectAndCompute(imgOriginal, None)  # punctele sunt creeate pe imaginea initiala
    img = cv2.imread(file_to_ocr)
    kp2, desc2 = orb.detectAndCompute(img, None)  # punctele sunt creeate pe imaginea care urmeaza a fi folosita
    bf = cv2.BFMatcher(cv2.NORM_HAMMING)
    matches = bf.match(desc2, desc1)  # coreleaza punctele de pe cele doua imagini
    matches.sort(key=lambda xd: xd.distance)
    good = matches[:int(len(matches) * (per / 100))]  # selectam un procentaj de puncte comune bune
    srcPoint = np.float32([kp2[m.queryIdx].pt for m in good]).reshape(-1, 1, 2)
    destPoint = np.float32([kp1[m.trainIdx].pt for m in good]).reshape(-1, 1, 2)
    M, _ = cv2.findHomography(srcPoint, destPoint, cv2.RANSAC, 5.0)
    # imgScan = cv2.warpPerspective(img, M, (w, h))  # pozitioneaza imaginea cat mai aproape de original
    imgShow = img.copy()

    myData = {}
    for x, r in enumerate(roi):
        imgCrop = imgShow[r[0][1]:r[1][1], r[0][0]:r[1][0]]  # face crop din dreptunghiul de mai sus
        if r[2] == 'text':  # daca tipul campului este text, crop-ul va fi trimis spre ocr
            myData[r[3]] = (pytesseract.image_to_string(imgCrop)).replace("\n", " ")
    if converted == 1:
        if os.path.exists(file_to_delete):
            os.remove(file_to_delete)
    UploadedFile.objects.filter(id=file_id).update(search_metadata=myData, is_ocr=1)


def convert_pdf2img(input_file: str, pages: Tuple = None):
    """Converts pdf to image and generates a file by page"""
    # Open the document
    pdfIn = fitz.open(input_file)
    output_files = []
    # Iterate throughout the pages
    for pg in range(pdfIn.pageCount):
        if str(pages) != str(None):
            if str(pg) not in str(pages):
                continue
        if pg == 0:
            # Select a page
            page = pdfIn[pg]
            rotate = int(0)
            # PDF Page is converted into a whole picture 1056*816 and then for each picture a screenshot is taken.
            # zoom = 1.33333333 -----> Image size = 1056*816 zoom = 2 ---> 2 * Default Resolution (text is clear,
            # image text is hard to read)    = filesize small / Image size = 1584*1224 zoom = 4 ---> 4 * Default
            # Resolution (text is clear, image text is barely readable) = filesize large zoom = 8 ---> 8 * Default
            # Resolution (text is clear, image text is readable) = filesize large
            zoom_x = 2.9
            zoom_y = 2.9
            # The zoom factor is equal to 2 in order to make text clear
            # Pre-rotate is to rotate if needed.
            mat = fitz.Matrix(zoom_x, zoom_y).preRotate(rotate)
            pix = page.getPixmap(matrix=mat, alpha=False)
            output_file = f"{os.path.splitext(os.path.basename(input_file))[0]}_page{pg + 1}.png"
            pix.writePNG(output_file)
            output_files.append(output_file)
    pdfIn.close()
    return output_files[0]

archive/forms.py
from crispy_forms.helper import FormHelper
from crispy_forms.layout import HTML, Layout
from django.forms import *

from archive.models import *


class ArchiveForm(ModelForm):
    class Meta:
        model = Archive
        fields = '__all__'
        widgets = {
            'archive_name': TextInput(attrs={
                'placeholder': 'Please insert Archive name',
                'class': 'form-control'
            }),
            'description': TextInput(attrs={
                'placeholder': 'Please insert Archive description',
                'class': 'form-control'
            }),
        }

    def __init__(self, *args, **kwargs):
        super(ArchiveForm, self).__init__(*args, **kwargs)
        self.fields['archive_name'].required = True
        self.fields['description'].required = False
        self.fields['created_by'].widget = HiddenInput()

    def clean(self):
        cleaned_data = self.cleaned_data
        get_name = cleaned_data.get('archive_name')
        all_archives = Archive.objects.all()
        for archive in all_archives:
            if archive.archive_name == get_name:
                msg = 'This Archive already exist'
                self._errors['archive_name'] = self.error_class([msg])
        return cleaned_data


class CollectionForm(ModelForm):
    class Meta:
        model = Collection
        fields = '__all__'
        widgets = {
            'collection_name': TextInput(attrs={
                'placeholder': 'Please insert Collection name',
                'class': 'form-control'
            })
        }

    def __init__(self, archive=None, parent_collection=None, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields['archive'].widget = HiddenInput()
        self.fields['parent_collection'].widget = HiddenInput()
        if archive:
            self.fields['archive'].initial = archive
        if parent_collection:
            self.fields['parent_collection'].initial = parent_collection


class DocumentTemplateForm(ModelForm):
    class Meta:
        model = DocumentTemplate
        fields = '__all__'

    def __init__(self, *args, **kwargs):
        super(DocumentTemplateForm, self).__init__(*args, **kwargs)
        self.fields['dt_name'].widget.attrs['id'] = 'dt_name'
        self.fields['template_file'].widget.attrs['id'] = 'template_file'
        self.fields['archive'].widget = HiddenInput()


class RegionOfInterestForm(ModelForm):
    class Meta:
        model = RegionOfInterest
        fields = '__all__'
        labels = {
            'roi_name': 'Region name',
            "region_points": u"Region Points"
        }
        widgets = {
            'roi_name': TextInput(attrs={
                'placeholder': 'Please insert the name of the field',
                'class': 'form-control'
            }),
            'region_points': TextInput(attrs={
                'id': 'region_points'
            }),
        }

    def __init__(self, *args, **kwargs):
        super(RegionOfInterestForm, self).__init__(*args, **kwargs)
        self.fields['roi_name'].required = True
        self.fields['region_points'].widget = HiddenInput()
        self.fields['document_template'].widget = HiddenInput()


class UploadFileForm(ModelForm):
    class Meta:
        model = UploadedFile
        fields = '__all__'

        labels = {
            'filename': 'Select File to Upload'
        }

    def __init__(self, created_by=None, collection=None, *args, **kwargs):
        super(UploadFileForm, self).__init__(*args, **kwargs)
        self.fields['filename'].required = True
        self.fields['search_metadata'].widget = HiddenInput()
        self.fields['is_ocr'].widget = HiddenInput()
        self.fields['document_template'].widget = HiddenInput()
        self.fields['created_by'].widget = HiddenInput()
        self.fields['collection'].widget = HiddenInput()
        if created_by:
            self.fields['created_by'].initial = created_by
        if collection:
            self.fields['collection'].initial = collection

templates/archive/create_archive.html
{% extends 'base.html' %}
{% block title %} Create Archive {% endblock %}
{% block content %}
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <label for='id_got_template'> Add Template &nbsp;</label><input type='checkbox' name='box1'
                                                                        id='id_got_template'>
        <br>
        <div class="container" style="display: none" id="id_template">
            <div class="mb-3">
                <label for="formFile" class="form-label">Incarca Template</label>
                <input class="form-control" type="file" id="formFile">
            </div>
        </div>
        <label for='id_got_template'> Add Template &nbsp;</label><input type='checkbox' name='box1'
                                                                        id='id_got_template'>
        <br>
        <button type="submit" class="btn btn-primary">Submit</button>

    </form>


    <script>
        $(function () {
            $('#id_got_template').click(function () {
                if ($('#id_got_template').is(':checked')) {
                    $('#id_template').show();
                } else {
                    $('#id_template').hide();
                }
            });
        });
    </script>
{% endblock %}

templates/archive/create_archive_new.html
{% extends 'base.html' %}
{% block title %} Create Archive {% endblock %}
{% block content %}
    <form class="form-control" id="archive_create_form" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        <div class="row row-eq-height row-col-2">
            <div class="row">
                <div class="col col-md-6 " id="archive_create_form">

                    {{ archive_create_form.as_p }}
                    <label for='dt_create'> Add Template (OCR) &nbsp;</label><input type='radio' name='box1'
                                                                                    id='dt_create'>
                    <br>
                    <label for='fields_create'> Add Fields (no OCR) &nbsp;</label><input type='radio' name='box2'
                                                                                         id='fields_create'>
                    <br>
                </div>
                <div class="col col-md-6 " id="collection_create_form">
                    {{ collection_form.as_p }}
                </div>
                <div class="col col-md-6 " id="dt_create_form" style="display: none">
                    {{ document_template_form.as_p }}
                </div>
            </div>
            <div class="row">
                <div class="col-6" id="roi_create_form" style="display: none">
                    {{ roi_form.as_p }}
                    <img id="roi_img" src="" alt="" style="height: 600px; width: 600px;">
                </div>
                <div class="col">
                    <div class="input_roi_wrap" id="input_roi" style="display: none">
                        <button class="add_roi_button btn btn-sm btn-primary mt-5">Add ROI</button>
                        <br>
                        <button id="roi_0" value="0" style="display: none"></button>

                    </div>
                </div>
            </div>
            <div class="col-6" id="fields_create_form" style="display: none">
                <div class="input_fields_wrap" id="input_fields">
                    <button class="add_field_button btn btn-sm btn-primary  ">Add More Fields</button>
                    <br>

                    <div><label for="field_1"></label><input class="fields" type="text" id="field_1"></div>
                </div>
            </div>
        </div>
        <br>
        <button type="submit" class="btn btn-primary btn-sm">Submit</button>

    </form>


    <script>
        {#$('#archive_create_form').submit(function () {#}
        {#    var types = [];#}
        {#    if ($("input[name='box1']").is(':checked')) {#}
        {#        $("input[name='ocr']").each(function () {#}
        {#            types.push($(this).val());#}
        {#        });#}
        {#        var ocrpoints = '{[' + types + ']}';#}
        {#        $('#id_region_points').val(ocrpoints);#}
        {#    } else {#}
        {#        $("input[name='no_ocr']").each(function () {#}
        {#            types.push($(this).val());#}
        {#        });#}
        {#        var rpoints = '{no-ocr:' + types + '}';#}
        {#        $('#id_region_points').val(rpoints);#}
        {#    }#}
        {#    return true;#}
        //});



        $(document).ready(function () {
            var max_fields = 10; //maximum input boxes allowed
            var wrapper = $(".input_fields_wrap"); //Fields wrapper
            var add_button = $(".add_field_button"); //Add button ID
            var x = 1; //initlal text box count
            $(add_button).click(function (e) { //on add input button click
                e.preventDefault();
                const field_name = 'field_' + x.toString()
                if ($('#' + field_name).val().length > 0) {
                    if (x < max_fields) { //max input box allowed
                        x++; //text box increment
                        const field_name = 'field_' + x.toString()
                        $(wrapper).append('<br><div><input class="fields" type="text" id="' + field_name + '" name="no_ocr" /><a href="#" class="remove_field bi bi-dash-circle"></a></div>'); //add input box
                    } else {
                        alert("Max fields reached")
                    }
                } else {
                    alert("add field name")
                }
            });

            $(wrapper).on("click", ".remove_field", function (e) { //user click on remove text
                e.preventDefault();
                $(this).parent('div').remove();
                x--;
            })
        });

        $(function () {
            $('#dt_create').click(function () {
                if ($('#dt_create').is(':checked')) {
                    $('#dt_create_form').show();
                    $('#fields_create').prop("checked", false);
                    $('#fields_create_form').hide();
                }
            });
            $('#fields_create').click(function () {
                if ($('#fields_create').is(':checked')) {
                    $('#dt_name').val('No-Name')
                    $('#id_roi_name').val('No-Name')
                    $('#fields_create_form').show();
                    $('#dt_create').prop("checked", false);
                    $('#dt_create_form').hide();
                }
            });

            $('#template_file').change(function () {
                if (this.files && this.files[0]) {
                    console.log(this.files)
                    var reader = new FileReader();
                    reader.onload = function (e) {
                        $('#roi_img').replaceWith('<img id="roi_img" class="img-fluid" src="' + e.target.result + '" alt=""/>')
                        var img = document.getElementById("roi_img");
                        var imgscale = img.naturalHeight / img.height
                        console.log(img.height, img.width);
                        console.log(img.naturalHeight, img.naturalWidth);
                        console.log(imgscale);
                        window.imgscale = imgscale
                    }
                    reader.readAsDataURL(this.files[0]);
                    $('#roi_create_form').show();
                    $('#input_roi').show();
                }

            });
        });
        var jcrop_api;
        $(document).ready(function () {

            var max_roi = 10; //maximum input boxes allowed
            var wrapper = $(".input_roi_wrap"); //Fields wrapper
            var add_roi_button = $(".add_roi_button"); //Add button ID
            var rx = 0; //initlal text box count
            $(add_roi_button).click(function (e) { //on add input button click
                e.preventDefault();
                const roi_name = 'roi_' + rx.toString()
                if ($('#' + roi_name).val().length > 0) {
                    if (rx < max_roi) { //max input box allowed
                        rx++; //text box increment
                        const roi_name = 'roi_' + rx.toString()
                        $(wrapper).append('<br>' +
                            '<div class="inline-labels">' +
                            '<div><input class="form-control-sm" type="text" id="' + roi_name + '" ' +
                            'size="20"/>' +
                            '<label class="ms-3">X1<input class="form-control-sm" type="text" id="x1' + roi_name + '" size="2"/></label> ' +
                            '<label>Y1<input class="form-control-sm" type="text" id="y1' + roi_name + '" size="2"/></label>' +
                            '<label>X2<input class="form-control-sm" type="text" id="x2' + roi_name + '" size="2"/></label>' +
                            '<label>Y2<input class="form-control-sm" type="text" id="y2' + roi_name + '" size="2"/></label>' +
                            '<label>Coord<input class="form-control-sm" type="text" id="w' + roi_name + '" name="ocr" size="30"/></label>' +
                            '<a href="#" class="remove_roi bi bi-trash text-danger m-2"></a>' +
                            '</div>' +
                            '</div>'); //add input box
                        initJcrop()

                        function initJcrop() {

                            $('#roi_img').Jcrop({

                                onRelease: function (coords) {
                                    $('#x1' + roi_name).val(Math.round(coords.x * imgscale));
                                    $('#y1' + roi_name).val(Math.round(coords.y * imgscale));
                                    $('#x2' + roi_name).val(Math.round(coords.x2 * imgscale));
                                    $('#y2' + roi_name).val(Math.round(coords.y2 * imgscale));
                                    $('#w' + roi_name).val('[(' + Math.round(coords.x* imgscale) + ',' + Math.round(coords.y* imgscale) + ')' + ',' + '(' + Math.round(coords.x2* imgscale) + ',' + Math.round(coords.y2* imgscale) + ') , "text" , "' + $('#' + roi_name).val() + '"]');
                                },
                                onSelect: function (coords) {
                                    $('#x1' + roi_name).val(Math.round(coords.x * imgscale));
                                    $('#y1' + roi_name).val(Math.round(coords.y * imgscale));
                                    $('#x2' + roi_name).val(Math.round(coords.x2 * imgscale));
                                    $('#y2' + roi_name).val(Math.round(coords.y2 * imgscale));
                                    $('#w' + roi_name).val('[(' + Math.round(coords.x* imgscale) + ',' + Math.round(coords.y* imgscale) + ')' + ',' + '(' + Math.round(coords.x2* imgscale) + ',' + Math.round(coords.y2* imgscale) + ') , "text" , "' + $('#' + roi_name).val() + '"]');
                                },
                            }, function () {
                                jcrop_api = this;
                            });
                        }

                        $('#roi_1').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_1').val(), $('#y1roi_1').val(), $('#x2roi_1').val(), $('#y2roi_1').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_2').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_2').val(), $('#y1roi_2').val(), $('#x2roi_2').val(), $('#y2roi_2').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_3').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_3').val(), $('#y1roi_3').val(), $('#x2roi_3').val(), $('#y2roi_3').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_4').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_4').val(), $('#y1roi_4').val(), $('#x2roi_4').val(), $('#y2roi_4').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_5').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_5').val(), $('#y1roi_5').val(), $('#x2roi_5').val(), $('#y2roi_5').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_6').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_6').val(), $('#y1roi_6').val(), $('#x2roi_6').val(), $('#y2roi_6').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_7').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_7').val(), $('#y1roi_7').val(), $('#x2roi_7').val(), $('#y2roi_7').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_8').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_8').val(), $('#y1roi_8').val(), $('#x2roi_8').val(), $('#y2roi_8').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_9').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_9').val(), $('#y1roi_9').val(), $('#x2roi_9').val(), $('#y2roi_9').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_10').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_10').val(), $('#y1roi_10').val(), $('#x2roi_10').val(), $('#y2roi_10').val()]);
                            jcrop_api.release()
                        });
                    } else {
                        alert("Max roi reached")
                    }
                } else {
                    alert("add roi name")
                }
            });

            $(wrapper).on("click", ".remove_roi", function (e) { //user click on remove text
                e.preventDefault();
                $(this).parent('div').remove();
                rx--;
            })
        });

    </script>
{% endblock %}

templates/archive/create_collection.html
{% extends 'base.html' %}
{% block title %} Create Collection {% endblock %}
{% block content %}
<div class="modal fade" id="ModelCreateCollection" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Modal title</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}

        </form>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="button" class="btn btn-primary">Save changes</button>
      </div>
    </div>
  </div>
</div>

        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button class="btn btn-primary" type="submit">Submit</button>
        </form>

{% endblock %}

templates/archive/delete_archive.html
     <p>Are you sure you want to delete this category : {{ archive.archive_name }} ?</p>
    <form method="post" action="{{ request.path }}">
        {% csrf_token %}
        <button type="submit" class="btn btn-danger">Delete</button>

    </form>

templates/archive/delete_collection.html
    <p>Are you sure you want to delete this category : {{ collection.collection_name }} ?</p>
    <form method="post" action="{{ request.path }}">
        {% csrf_token %}
        <button type="submit" class="btn btn-danger btn-sm">Delete</button>
    </form>

templates/archive/update_archive.html
{% extends 'base.html' %}
{% block title %} Update Archive {% endblock %}
{% block content %} {% endblock %}

templates/archive/update_collection.html
<form method="post" action="{{ request.path }}">
    {% csrf_token %}
    {{ form.as_p }}
    <button class="btn btn-success btn-sm" type="submit">Update</button>
</form>